package main

import (
	"database/sql"
	"log"
	"net/http"

	"github.com/uptrace/bun"
	"github.com/uptrace/bun/dialect/pgdialect"
	"github.com/uptrace/bun/driver/pgdriver"
	"golang.org/x/crypto/ssh"
	"golang.org/x/crypto/ssh/knownhosts"
)

func OpenDB(dsn string) *bun.DB {
	sqldb := sql.OpenDB(pgdriver.NewConnector(pgdriver.WithDSN(dsn)))
	r := bun.NewDB(sqldb, pgdialect.New())
	return r
}

func OpenHTTP() *http.Client {
	var cli *http.Client
	return cli
}
func OpenSSH(dsn string) *ssh.Client {
	knownHosts, _ := knownhosts.New("/home/m00t/.ssh/known_hosts")
	config := &ssh.ClientConfig{
		User: "admin",
		Auth: []ssh.AuthMethod{
			ssh.Password("Initial1"),
		},
		HostKeyCallback: knownHosts,
	}
	client, err := ssh.Dial("tcp", dsn, config)
	if err != nil {
		log.Fatal("Failed to dial: ", err)
	}
	defer client.Close()
	return client
}
