package main

import (
	"fmt"
)

// Tofu Provider is the goal
// Data Sources first
// Resources later

//var users []UserModel
//var ssh_keys []SSHKeyModel
//var servers []Server
//var server_definitions []ServerDefinition
//var manifests []Manifest
//var jobs []Job
//var hosts []Host

func main() {
	var (
		pgdsn  = "postgres://postgres:Initial1@localhost:15432/anvil?sslmode=disable"
		sshdsn = "192.168.1.165:22"
		//		webdsn = "http://192.168.1.165"
	)
	anvil := new(Anvil)
	anvil.AddStriker(Striker{})
	// anvil.Strikers[0].SetFQDN("mh-striker01.libre.audio")
	pge := &PostgresClient{OpenDB(pgdsn)}
	anvil.Strikers[0].AddEndpoint(pge)

	webe := &WebClient{OpenHTTP()}
	anvil.Strikers[0].AddEndpoint(webe)

	sshe := &SSHClient{OpenSSH(sshdsn)}
	anvil.Strikers[0].AddEndpoint(sshe)

	fmt.Printf("Strikers[0].Endpoints.PostgresClient = %s.\n", anvil.Strikers[0].Endpoints.PostgresClient)
	fmt.Printf("Strikers[0].Endpoints.WebClient = %s.\n", anvil.Strikers[0].Endpoints.WebClient)
	fmt.Printf("Strikers[0].Endpoints.SSHClient = %s.\n", anvil.Strikers[0].Endpoints.SSHClient)

	// fmt.Printf("Strikers[0].FQDN = %s.\n", anvil.Strikers[0].FQDN)
}
